/*
 * Stack.java
 *
 * Created on 24. duben 2007, 9:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.util.Date;

/**
 *
 * @author koci
 */
public class Stack {
    private Object[] el;
    private int size = 0;
    
    /** Creates a new instance of Stack */
    public Stack(int capacity) {
        this.el = new Object[capacity];
    }
    
    public void push(Object o) {
        ensureCapacity();
        el[size++] = o;
    }
    
    public Object pop() { //throws Exception {
//        if (size == 0)
//            throw new Exception();
        //return el[--size];
        Object res = el[--size];
        el[size] = null;
        return res;
    }
    
    private void ensureCapacity() {
        if (el.length == size) {
            Object[] old = el;
            el = new Object[2 * el.length + 1];
            System.arraycopy(old, 0, el, 0, size);
        }
    }
    
    public static void main(String[] argv) {
        Stack s = new Stack(1000000);
        for (int i = 0; i < 1000000; i++) {
            s.push(new Date());
        }
        for (int i = 0; i < 500000; i++) {
            s.pop();
        }
        Stack s2 = new Stack(500000);
        for (int i = 0; i < 500000; i++) {
            s2.push(new Date());
        }
    }
}
